/*
Copyright (C) 1997-2001 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
/*
** QGL.H
*/

#ifndef __QGL_H__
#define __QGL_H__

#ifdef _WIN32
#  include <windows.h>
#endif

#include "gl11.h"

qboolean QGL_Init( const char *dllname );
void     QGL_Shutdown( void );

#ifndef APIENTRY
#  define APIENTRY
#endif

void (APIENTRY *glAccum) (GLenum op, GLfloat value);
void (APIENTRY *glAlphaFunc) (GLenum func, GLclampf ref);
GLboolean (APIENTRY *glAreTexturesResident) (GLsizei n, const GLuint *textures, GLboolean *residences);
void (APIENTRY *glArrayElement) (GLint i);
void (APIENTRY *glBegin) (GLenum mode);
void (APIENTRY *glBindTexture) (GLenum target, GLuint texture);
void (APIENTRY *glBitmap) (GLsizei width, GLsizei height, GLfloat xorig, GLfloat yorig, GLfloat xmove, GLfloat ymove, const GLubyte *bitmap);
void (APIENTRY *glBlendFunc) (GLenum sfactor, GLenum dfactor);
void (APIENTRY *glCallList) (GLuint list);
void (APIENTRY *glCallLists) (GLsizei n, GLenum type, const GLvoid *lists);
void (APIENTRY *glClear) (GLbitfield mask);
void (APIENTRY *glClearAccum) (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
void (APIENTRY *glClearColor) (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
void (APIENTRY *glClearDepth) (GLclampd depth);
void (APIENTRY *glClearIndex) (GLfloat c);
void (APIENTRY *glClearStencil) (GLint s);
void (APIENTRY *glClipPlane) (GLenum plane, const GLdouble *equation);
void (APIENTRY *glColor3b) (GLbyte red, GLbyte green, GLbyte blue);
void (APIENTRY *glColor3bv) (const GLbyte *v);
void (APIENTRY *glColor3d) (GLdouble red, GLdouble green, GLdouble blue);
void (APIENTRY *glColor3dv) (const GLdouble *v);
void (APIENTRY *glColor3f) (GLfloat red, GLfloat green, GLfloat blue);
void (APIENTRY *glColor3fv) (const GLfloat *v);
void (APIENTRY *glColor3i) (GLint red, GLint green, GLint blue);
void (APIENTRY *glColor3iv) (const GLint *v);
void (APIENTRY *glColor3s) (GLshort red, GLshort green, GLshort blue);
void (APIENTRY *glColor3sv) (const GLshort *v);
void (APIENTRY *glColor3ub) (GLubyte red, GLubyte green, GLubyte blue);
void (APIENTRY *glColor3ubv) (const GLubyte *v);
void (APIENTRY *glColor3ui) (GLuint red, GLuint green, GLuint blue);
void (APIENTRY *glColor3uiv) (const GLuint *v);
void (APIENTRY *glColor3us) (GLushort red, GLushort green, GLushort blue);
void (APIENTRY *glColor3usv) (const GLushort *v);
void (APIENTRY *glColor4b) (GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha);
void (APIENTRY *glColor4bv) (const GLbyte *v);
void (APIENTRY *glColor4d) (GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha);
void (APIENTRY *glColor4dv) (const GLdouble *v);
void (APIENTRY *glColor4f) (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
void (APIENTRY *glColor4fv) (const GLfloat *v);
void (APIENTRY *glColor4i) (GLint red, GLint green, GLint blue, GLint alpha);
void (APIENTRY *glColor4iv) (const GLint *v);
void (APIENTRY *glColor4s) (GLshort red, GLshort green, GLshort blue, GLshort alpha);
void (APIENTRY *glColor4sv) (const GLshort *v);
void (APIENTRY *glColor4ub) (GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha);
void (APIENTRY *glColor4ubv) (const GLubyte *v);
void (APIENTRY *glColor4ui) (GLuint red, GLuint green, GLuint blue, GLuint alpha);
void (APIENTRY *glColor4uiv) (const GLuint *v);
void (APIENTRY *glColor4us) (GLushort red, GLushort green, GLushort blue, GLushort alpha);
void (APIENTRY *glColor4usv) (const GLushort *v);
void (APIENTRY *glColorMask) (GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);
void (APIENTRY *glColorMaterial) (GLenum face, GLenum mode);
void (APIENTRY *glColorPointer) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
void (APIENTRY *glCopyPixels) (GLint x, GLint y, GLsizei width, GLsizei height, GLenum type);
void (APIENTRY *glCopyTexImage1D) (GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLint border);
void (APIENTRY *glCopyTexImage2D) (GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border);
void (APIENTRY *glCopyTexSubImage1D) (GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width);
void (APIENTRY *glCopyTexSubImage2D) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
void (APIENTRY *glCullFace) (GLenum mode);
void (APIENTRY *glDeleteLists) (GLuint list, GLsizei range);
void (APIENTRY *glDeleteTextures) (GLsizei n, const GLuint *textures);
void (APIENTRY *glDepthFunc) (GLenum func);
void (APIENTRY *glDepthMask) (GLboolean flag);
void (APIENTRY *glDepthRange) (GLclampd zNear, GLclampd zFar);
void (APIENTRY *glDisable) (GLenum cap);
void (APIENTRY *glDisableClientState) (GLenum array);
void (APIENTRY *glDrawArrays) (GLenum mode, GLint first, GLsizei count);
void (APIENTRY *glDrawBuffer) (GLenum mode);
void (APIENTRY *glDrawElements) (GLenum mode, GLsizei count, GLenum type, const GLvoid *indices);
void (APIENTRY *glDrawPixels) (GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
void (APIENTRY *glEdgeFlag) (GLboolean flag);
void (APIENTRY *glEdgeFlagPointer) (GLsizei stride, const GLvoid *pointer);
void (APIENTRY *glEdgeFlagv) (const GLboolean *flag);
void (APIENTRY *glEnable) (GLenum cap);
void (APIENTRY *glEnableClientState) (GLenum array);
void (APIENTRY *glEnd) (void);
void (APIENTRY *glEndList) (void);
void (APIENTRY *glEvalCoord1d) (GLdouble u);
void (APIENTRY *glEvalCoord1dv) (const GLdouble *u);
void (APIENTRY *glEvalCoord1f) (GLfloat u);
void (APIENTRY *glEvalCoord1fv) (const GLfloat *u);
void (APIENTRY *glEvalCoord2d) (GLdouble u, GLdouble v);
void (APIENTRY *glEvalCoord2dv) (const GLdouble *u);
void (APIENTRY *glEvalCoord2f) (GLfloat u, GLfloat v);
void (APIENTRY *glEvalCoord2fv) (const GLfloat *u);
void (APIENTRY *glEvalMesh1) (GLenum mode, GLint i1, GLint i2);
void (APIENTRY *glEvalMesh2) (GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2);
void (APIENTRY *glEvalPoint1) (GLint i);
void (APIENTRY *glEvalPoint2) (GLint i, GLint j);
void (APIENTRY *glFeedbackBuffer) (GLsizei size, GLenum type, GLfloat *buffer);
void (APIENTRY *glFinish) (void);
void (APIENTRY *glFlush) (void);
void (APIENTRY *glFogf) (GLenum pname, GLfloat param);
void (APIENTRY *glFogfv) (GLenum pname, const GLfloat *params);
void (APIENTRY *glFogi) (GLenum pname, GLint param);
void (APIENTRY *glFogiv) (GLenum pname, const GLint *params);
void (APIENTRY *glFrontFace) (GLenum mode);
void (APIENTRY *glFrustum) (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
GLuint (APIENTRY *glGenLists) (GLsizei range);
void (APIENTRY *glGenTextures) (GLsizei n, GLuint *textures);
void (APIENTRY *glGetBooleanv) (GLenum pname, GLboolean *params);
void (APIENTRY *glGetClipPlane) (GLenum plane, GLdouble *equation);
void (APIENTRY *glGetDoublev) (GLenum pname, GLdouble *params);
GLenum (APIENTRY *glGetError) (void);
void (APIENTRY *glGetFloatv) (GLenum pname, GLfloat *params);
void (APIENTRY *glGetIntegerv) (GLenum pname, GLint *params);
void (APIENTRY *glGetLightfv) (GLenum light, GLenum pname, GLfloat *params);
void (APIENTRY *glGetLightiv) (GLenum light, GLenum pname, GLint *params);
void (APIENTRY *glGetMapdv) (GLenum target, GLenum query, GLdouble *v);
void (APIENTRY *glGetMapfv) (GLenum target, GLenum query, GLfloat *v);
void (APIENTRY *glGetMapiv) (GLenum target, GLenum query, GLint *v);
void (APIENTRY *glGetMaterialfv) (GLenum face, GLenum pname, GLfloat *params);
void (APIENTRY *glGetMaterialiv) (GLenum face, GLenum pname, GLint *params);
void (APIENTRY *glGetPixelMapfv) (GLenum map, GLfloat *values);
void (APIENTRY *glGetPixelMapuiv) (GLenum map, GLuint *values);
void (APIENTRY *glGetPixelMapusv) (GLenum map, GLushort *values);
void (APIENTRY *glGetPointerv) (GLenum pname, GLvoid* *params);
void (APIENTRY *glGetPolygonStipple) (GLubyte *mask);
const GLubyte * (APIENTRY *glGetString) (GLenum name);
void (APIENTRY *glGetTexEnvfv) (GLenum target, GLenum pname, GLfloat *params);
void (APIENTRY *glGetTexEnviv) (GLenum target, GLenum pname, GLint *params);
void (APIENTRY *glGetTexGendv) (GLenum coord, GLenum pname, GLdouble *params);
void (APIENTRY *glGetTexGenfv) (GLenum coord, GLenum pname, GLfloat *params);
void (APIENTRY *glGetTexGeniv) (GLenum coord, GLenum pname, GLint *params);
void (APIENTRY *glGetTexImage) (GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels);
void (APIENTRY *glGetTexLevelParameterfv) (GLenum target, GLint level, GLenum pname, GLfloat *params);
void (APIENTRY *glGetTexLevelParameteriv) (GLenum target, GLint level, GLenum pname, GLint *params);
void (APIENTRY *glGetTexParameterfv) (GLenum target, GLenum pname, GLfloat *params);
void (APIENTRY *glGetTexParameteriv) (GLenum target, GLenum pname, GLint *params);
void (APIENTRY *glHint) (GLenum target, GLenum mode);
void (APIENTRY *glIndexMask) (GLuint mask);
void (APIENTRY *glIndexPointer) (GLenum type, GLsizei stride, const GLvoid *pointer);
void (APIENTRY *glIndexd) (GLdouble c);
void (APIENTRY *glIndexdv) (const GLdouble *c);
void (APIENTRY *glIndexf) (GLfloat c);
void (APIENTRY *glIndexfv) (const GLfloat *c);
void (APIENTRY *glIndexi) (GLint c);
void (APIENTRY *glIndexiv) (const GLint *c);
void (APIENTRY *glIndexs) (GLshort c);
void (APIENTRY *glIndexsv) (const GLshort *c);
void (APIENTRY *glIndexub) (GLubyte c);
void (APIENTRY *glIndexubv) (const GLubyte *c);
void (APIENTRY *glInitNames) (void);
void (APIENTRY *glInterleavedArrays) (GLenum format, GLsizei stride, const GLvoid *pointer);
GLboolean (APIENTRY *glIsEnabled) (GLenum cap);
GLboolean (APIENTRY *glIsList) (GLuint list);
GLboolean (APIENTRY *glIsTexture) (GLuint texture);
void (APIENTRY *glLightModelf) (GLenum pname, GLfloat param);
void (APIENTRY *glLightModelfv) (GLenum pname, const GLfloat *params);
void (APIENTRY *glLightModeli) (GLenum pname, GLint param);
void (APIENTRY *glLightModeliv) (GLenum pname, const GLint *params);
void (APIENTRY *glLightf) (GLenum light, GLenum pname, GLfloat param);
void (APIENTRY *glLightfv) (GLenum light, GLenum pname, const GLfloat *params);
void (APIENTRY *glLighti) (GLenum light, GLenum pname, GLint param);
void (APIENTRY *glLightiv) (GLenum light, GLenum pname, const GLint *params);
void (APIENTRY *glLineStipple) (GLint factor, GLushort pattern);
void (APIENTRY *glLineWidth) (GLfloat width);
void (APIENTRY *glListBase) (GLuint base);
void (APIENTRY *glLoadIdentity) (void);
void (APIENTRY *glLoadMatrixd) (const GLdouble *m);
void (APIENTRY *glLoadMatrixf) (const GLfloat *m);
void (APIENTRY *glLoadName) (GLuint name);
void (APIENTRY *glLogicOp) (GLenum opcode);
void (APIENTRY *glMap1d) (GLenum target, GLdouble u1, GLdouble u2, GLint stride, GLint order, const GLdouble *points);
void (APIENTRY *glMap1f) (GLenum target, GLfloat u1, GLfloat u2, GLint stride, GLint order, const GLfloat *points);
void (APIENTRY *glMap2d) (GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, const GLdouble *points);
void (APIENTRY *glMap2f) (GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, const GLfloat *points);
void (APIENTRY *glMapGrid1d) (GLint un, GLdouble u1, GLdouble u2);
void (APIENTRY *glMapGrid1f) (GLint un, GLfloat u1, GLfloat u2);
void (APIENTRY *glMapGrid2d) (GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2);
void (APIENTRY *glMapGrid2f) (GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2);
void (APIENTRY *glMaterialf) (GLenum face, GLenum pname, GLfloat param);
void (APIENTRY *glMaterialfv) (GLenum face, GLenum pname, const GLfloat *params);
void (APIENTRY *glMateriali) (GLenum face, GLenum pname, GLint param);
void (APIENTRY *glMaterialiv) (GLenum face, GLenum pname, const GLint *params);
void (APIENTRY *glMatrixMode) (GLenum mode);
void (APIENTRY *glMultMatrixd) (const GLdouble *m);
void (APIENTRY *glMultMatrixf) (const GLfloat *m);
void (APIENTRY *glNewList) (GLuint list, GLenum mode);
void (APIENTRY *glNormal3b) (GLbyte nx, GLbyte ny, GLbyte nz);
void (APIENTRY *glNormal3bv) (const GLbyte *v);
void (APIENTRY *glNormal3d) (GLdouble nx, GLdouble ny, GLdouble nz);
void (APIENTRY *glNormal3dv) (const GLdouble *v);
void (APIENTRY *glNormal3f) (GLfloat nx, GLfloat ny, GLfloat nz);
void (APIENTRY *glNormal3fv) (const GLfloat *v);
void (APIENTRY *glNormal3i) (GLint nx, GLint ny, GLint nz);
void (APIENTRY *glNormal3iv) (const GLint *v);
void (APIENTRY *glNormal3s) (GLshort nx, GLshort ny, GLshort nz);
void (APIENTRY *glNormal3sv) (const GLshort *v);
void (APIENTRY *glNormalPointer) (GLenum type, GLsizei stride, const GLvoid *pointer);
void (APIENTRY *glOrtho) (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
void (APIENTRY *glPassThrough) (GLfloat token);
void (APIENTRY *glPixelMapfv) (GLenum map, GLsizei mapsize, const GLfloat *values);
void (APIENTRY *glPixelMapuiv) (GLenum map, GLsizei mapsize, const GLuint *values);
void (APIENTRY *glPixelMapusv) (GLenum map, GLsizei mapsize, const GLushort *values);
void (APIENTRY *glPixelStoref) (GLenum pname, GLfloat param);
void (APIENTRY *glPixelStorei) (GLenum pname, GLint param);
void (APIENTRY *glPixelTransferf) (GLenum pname, GLfloat param);
void (APIENTRY *glPixelTransferi) (GLenum pname, GLint param);
void (APIENTRY *glPixelZoom) (GLfloat xfactor, GLfloat yfactor);
void (APIENTRY *glPointSize) (GLfloat size);
void (APIENTRY *glPolygonMode) (GLenum face, GLenum mode);
void (APIENTRY *glPolygonOffset) (GLfloat factor, GLfloat units);
void (APIENTRY *glPolygonStipple) (const GLubyte *mask);
void (APIENTRY *glPopAttrib) (void);
void (APIENTRY *glPopClientAttrib) (void);
void (APIENTRY *glPopMatrix) (void);
void (APIENTRY *glPopName) (void);
void (APIENTRY *glPrioritizeTextures) (GLsizei n, const GLuint *textures, const GLclampf *priorities);
void (APIENTRY *glPushAttrib) (GLbitfield mask);
void (APIENTRY *glPushClientAttrib) (GLbitfield mask);
void (APIENTRY *glPushMatrix) (void);
void (APIENTRY *glPushName) (GLuint name);
void (APIENTRY *glRasterPos2d) (GLdouble x, GLdouble y);
void (APIENTRY *glRasterPos2dv) (const GLdouble *v);
void (APIENTRY *glRasterPos2f) (GLfloat x, GLfloat y);
void (APIENTRY *glRasterPos2fv) (const GLfloat *v);
void (APIENTRY *glRasterPos2i) (GLint x, GLint y);
void (APIENTRY *glRasterPos2iv) (const GLint *v);
void (APIENTRY *glRasterPos2s) (GLshort x, GLshort y);
void (APIENTRY *glRasterPos2sv) (const GLshort *v);
void (APIENTRY *glRasterPos3d) (GLdouble x, GLdouble y, GLdouble z);
void (APIENTRY *glRasterPos3dv) (const GLdouble *v);
void (APIENTRY *glRasterPos3f) (GLfloat x, GLfloat y, GLfloat z);
void (APIENTRY *glRasterPos3fv) (const GLfloat *v);
void (APIENTRY *glRasterPos3i) (GLint x, GLint y, GLint z);
void (APIENTRY *glRasterPos3iv) (const GLint *v);
void (APIENTRY *glRasterPos3s) (GLshort x, GLshort y, GLshort z);
void (APIENTRY *glRasterPos3sv) (const GLshort *v);
void (APIENTRY *glRasterPos4d) (GLdouble x, GLdouble y, GLdouble z, GLdouble w);
void (APIENTRY *glRasterPos4dv) (const GLdouble *v);
void (APIENTRY *glRasterPos4f) (GLfloat x, GLfloat y, GLfloat z, GLfloat w);
void (APIENTRY *glRasterPos4fv) (const GLfloat *v);
void (APIENTRY *glRasterPos4i) (GLint x, GLint y, GLint z, GLint w);
void (APIENTRY *glRasterPos4iv) (const GLint *v);
void (APIENTRY *glRasterPos4s) (GLshort x, GLshort y, GLshort z, GLshort w);
void (APIENTRY *glRasterPos4sv) (const GLshort *v);
void (APIENTRY *glReadBuffer) (GLenum mode);
void (APIENTRY *glReadPixels) (GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels);
void (APIENTRY *glRectd) (GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2);
void (APIENTRY *glRectdv) (const GLdouble *v1, const GLdouble *v2);
void (APIENTRY *glRectf) (GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2);
void (APIENTRY *glRectfv) (const GLfloat *v1, const GLfloat *v2);
void (APIENTRY *glRecti) (GLint x1, GLint y1, GLint x2, GLint y2);
void (APIENTRY *glRectiv) (const GLint *v1, const GLint *v2);
void (APIENTRY *glRects) (GLshort x1, GLshort y1, GLshort x2, GLshort y2);
void (APIENTRY *glRectsv) (const GLshort *v1, const GLshort *v2);
GLint (APIENTRY *glRenderMode) (GLenum mode);
void (APIENTRY *glRotated) (GLdouble angle, GLdouble x, GLdouble y, GLdouble z);
void (APIENTRY *glRotatef) (GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
void (APIENTRY *glScaled) (GLdouble x, GLdouble y, GLdouble z);
void (APIENTRY *glScalef) (GLfloat x, GLfloat y, GLfloat z);
void (APIENTRY *glScissor) (GLint x, GLint y, GLsizei width, GLsizei height);
void (APIENTRY *glSelectBuffer) (GLsizei size, GLuint *buffer);
void (APIENTRY *glShadeModel) (GLenum mode);
void (APIENTRY *glStencilFunc) (GLenum func, GLint ref, GLuint mask);
void (APIENTRY *glStencilMask) (GLuint mask);
void (APIENTRY *glStencilOp) (GLenum fail, GLenum zfail, GLenum zpass);
void (APIENTRY *glTexCoord1d) (GLdouble s);
void (APIENTRY *glTexCoord1dv) (const GLdouble *v);
void (APIENTRY *glTexCoord1f) (GLfloat s);
void (APIENTRY *glTexCoord1fv) (const GLfloat *v);
void (APIENTRY *glTexCoord1i) (GLint s);
void (APIENTRY *glTexCoord1iv) (const GLint *v);
void (APIENTRY *glTexCoord1s) (GLshort s);
void (APIENTRY *glTexCoord1sv) (const GLshort *v);
void (APIENTRY *glTexCoord2d) (GLdouble s, GLdouble t);
void (APIENTRY *glTexCoord2dv) (const GLdouble *v);
void (APIENTRY *glTexCoord2f) (GLfloat s, GLfloat t);
void (APIENTRY *glTexCoord2fv) (const GLfloat *v);
void (APIENTRY *glTexCoord2i) (GLint s, GLint t);
void (APIENTRY *glTexCoord2iv) (const GLint *v);
void (APIENTRY *glTexCoord2s) (GLshort s, GLshort t);
void (APIENTRY *glTexCoord2sv) (const GLshort *v);
void (APIENTRY *glTexCoord3d) (GLdouble s, GLdouble t, GLdouble r);
void (APIENTRY *glTexCoord3dv) (const GLdouble *v);
void (APIENTRY *glTexCoord3f) (GLfloat s, GLfloat t, GLfloat r);
void (APIENTRY *glTexCoord3fv) (const GLfloat *v);
void (APIENTRY *glTexCoord3i) (GLint s, GLint t, GLint r);
void (APIENTRY *glTexCoord3iv) (const GLint *v);
void (APIENTRY *glTexCoord3s) (GLshort s, GLshort t, GLshort r);
void (APIENTRY *glTexCoord3sv) (const GLshort *v);
void (APIENTRY *glTexCoord4d) (GLdouble s, GLdouble t, GLdouble r, GLdouble q);
void (APIENTRY *glTexCoord4dv) (const GLdouble *v);
void (APIENTRY *glTexCoord4f) (GLfloat s, GLfloat t, GLfloat r, GLfloat q);
void (APIENTRY *glTexCoord4fv) (const GLfloat *v);
void (APIENTRY *glTexCoord4i) (GLint s, GLint t, GLint r, GLint q);
void (APIENTRY *glTexCoord4iv) (const GLint *v);
void (APIENTRY *glTexCoord4s) (GLshort s, GLshort t, GLshort r, GLshort q);
void (APIENTRY *glTexCoord4sv) (const GLshort *v);
void (APIENTRY *glTexCoordPointer) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
void (APIENTRY *glTexEnvf) (GLenum target, GLenum pname, GLfloat param);
void (APIENTRY *glTexEnvfv) (GLenum target, GLenum pname, const GLfloat *params);
void (APIENTRY *glTexEnvi) (GLenum target, GLenum pname, GLint param);
void (APIENTRY *glTexEnviv) (GLenum target, GLenum pname, const GLint *params);
void (APIENTRY *glTexGend) (GLenum coord, GLenum pname, GLdouble param);
void (APIENTRY *glTexGendv) (GLenum coord, GLenum pname, const GLdouble *params);
void (APIENTRY *glTexGenf) (GLenum coord, GLenum pname, GLfloat param);
void (APIENTRY *glTexGenfv) (GLenum coord, GLenum pname, const GLfloat *params);
void (APIENTRY *glTexGeni) (GLenum coord, GLenum pname, GLint param);
void (APIENTRY *glTexGeniv) (GLenum coord, GLenum pname, const GLint *params);
void (APIENTRY *glTexImage1D) (GLenum target, GLint level, GLint internalformat, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
void (APIENTRY *glTexImage2D) (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
void (APIENTRY *glTexParameterf) (GLenum target, GLenum pname, GLfloat param);
void (APIENTRY *glTexParameterfv) (GLenum target, GLenum pname, const GLfloat *params);
void (APIENTRY *glTexParameteri) (GLenum target, GLenum pname, GLint param);
void (APIENTRY *glTexParameteriv) (GLenum target, GLenum pname, const GLint *params);
void (APIENTRY *glTexSubImage1D) (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels);
void (APIENTRY *glTexSubImage2D) (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
void (APIENTRY *glTranslated) (GLdouble x, GLdouble y, GLdouble z);
void (APIENTRY *glTranslatef) (GLfloat x, GLfloat y, GLfloat z);
void (APIENTRY *glVertex2d) (GLdouble x, GLdouble y);
void (APIENTRY *glVertex2dv) (const GLdouble *v);
void (APIENTRY *glVertex2f) (GLfloat x, GLfloat y);
void (APIENTRY *glVertex2fv) (const GLfloat *v);
void (APIENTRY *glVertex2i) (GLint x, GLint y);
void (APIENTRY *glVertex2iv) (const GLint *v);
void (APIENTRY *glVertex2s) (GLshort x, GLshort y);
void (APIENTRY *glVertex2sv) (const GLshort *v);
void (APIENTRY *glVertex3d) (GLdouble x, GLdouble y, GLdouble z);
void (APIENTRY *glVertex3dv) (const GLdouble *v);
void (APIENTRY *glVertex3f) (GLfloat x, GLfloat y, GLfloat z);
void (APIENTRY *glVertex3fv) (const GLfloat *v);
void (APIENTRY *glVertex3i) (GLint x, GLint y, GLint z);
void (APIENTRY *glVertex3iv) (const GLint *v);
void (APIENTRY *glVertex3s) (GLshort x, GLshort y, GLshort z);
void (APIENTRY *glVertex3sv) (const GLshort *v);
void (APIENTRY *glVertex4d) (GLdouble x, GLdouble y, GLdouble z, GLdouble w);
void (APIENTRY *glVertex4dv) (const GLdouble *v);
void (APIENTRY *glVertex4f) (GLfloat x, GLfloat y, GLfloat z, GLfloat w);
void (APIENTRY *glVertex4fv) (const GLfloat *v);
void (APIENTRY *glVertex4i) (GLint x, GLint y, GLint z, GLint w);
void (APIENTRY *glVertex4iv) (const GLint *v);
void (APIENTRY *glVertex4s) (GLshort x, GLshort y, GLshort z, GLshort w);
void (APIENTRY *glVertex4sv) (const GLshort *v);
void (APIENTRY *glVertexPointer) (GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
void (APIENTRY *glViewport) (GLint x, GLint y, GLsizei width, GLsizei height);
void (APIENTRY *glLockArrays) (int , int);
void (APIENTRY *glUnlockArrays) (void);

void (APIENTRY *glBlendColor) (GLclampf, GLclampf, GLclampf, GLclampf);
void (APIENTRY *glBlendEquation) (GLenum);
void (APIENTRY *glDrawRangeElements) (GLenum, GLuint, GLuint, GLsizei, GLenum, const GLvoid *);
void (APIENTRY *glColorTable) (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
void (APIENTRY *glColorTableParameterfv) (GLenum, GLenum, const GLfloat *);
void (APIENTRY *glColorTableParameteriv) (GLenum, GLenum, const GLint *);
void (APIENTRY *glCopyColorTable) (GLenum, GLenum, GLint, GLint, GLsizei);
void (APIENTRY *glGetColorTable) (GLenum, GLenum, GLenum, GLvoid *);
void (APIENTRY *glGetColorTableParameterfv) (GLenum, GLenum, GLfloat *);
void (APIENTRY *glGetColorTableParameteriv) (GLenum, GLenum, GLint *);
void (APIENTRY *glColorSubTable) (GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
void (APIENTRY *glCopyColorSubTable) (GLenum, GLsizei, GLint, GLint, GLsizei);
void (APIENTRY *glConvolutionFilter1D) (GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid *);
void (APIENTRY *glConvolutionFilter2D) (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
void (APIENTRY *glConvolutionParameterf) (GLenum, GLenum, GLfloat);
void (APIENTRY *glConvolutionParameterfv) (GLenum, GLenum, const GLfloat *);
void (APIENTRY *glConvolutionParameteri) (GLenum, GLenum, GLint);
void (APIENTRY *glConvolutionParameteriv) (GLenum, GLenum, const GLint *);
void (APIENTRY *glCopyConvolutionFilter1D) (GLenum, GLenum, GLint, GLint, GLsizei);
void (APIENTRY *glCopyConvolutionFilter2D) (GLenum, GLenum, GLint, GLint, GLsizei, GLsizei);
void (APIENTRY *glGetConvolutionFilter) (GLenum, GLenum, GLenum, GLvoid *);
void (APIENTRY *glGetConvolutionParameterfv) (GLenum, GLenum, GLfloat *);
void (APIENTRY *glGetConvolutionParameteriv) (GLenum, GLenum, GLint *);
void (APIENTRY *glGetSeparableFilter) (GLenum, GLenum, GLenum, GLvoid *, GLvoid *, GLvoid *);
void (APIENTRY *glSeparableFilter2D) (GLenum, GLenum, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *, const GLvoid *);
void (APIENTRY *glGetHistogram) (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
void (APIENTRY *glGetHistogramParameterfv) (GLenum, GLenum, GLfloat *);
void (APIENTRY *glGetHistogramParameteriv) (GLenum, GLenum, GLint *);
void (APIENTRY *glGetMinmax) (GLenum, GLboolean, GLenum, GLenum, GLvoid *);
void (APIENTRY *glGetMinmaxParameterfv) (GLenum, GLenum, GLfloat *);
void (APIENTRY *glGetMinmaxParameteriv) (GLenum, GLenum, GLint *);
void (APIENTRY *glHistogram) (GLenum, GLsizei, GLenum, GLboolean);
void (APIENTRY *glMinmax) (GLenum, GLenum, GLboolean);
void (APIENTRY *glResetHistogram) (GLenum);
void (APIENTRY *glResetMinmax) (GLenum);
void (APIENTRY *glTexImage3D) (GLenum, GLint, GLint, GLsizei, GLsizei, GLsizei, GLint, GLenum, GLenum, const GLvoid *);
void (APIENTRY *glTexSubImage3D) (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLenum, const GLvoid *);
void (APIENTRY *glCopyTexSubImage3D) (GLenum, GLint, GLint, GLint, GLint, GLint, GLint, GLsizei, GLsizei);


// OpenGL 1.3 Prototypes
void (APIENTRY *glActiveTexture) (GLenum);
void (APIENTRY *glClientActiveTexture) (GLenum);
void (APIENTRY *glMultiTexCoord1d) (GLenum, GLdouble);
void (APIENTRY *glMultiTexCoord1dv) (GLenum, const GLdouble *);
void (APIENTRY *glMultiTexCoord1f) (GLenum, GLfloat);
void (APIENTRY *glMultiTexCoord1fv) (GLenum, const GLfloat *);
void (APIENTRY *glMultiTexCoord1i) (GLenum, GLint);
void (APIENTRY *glMultiTexCoord1iv) (GLenum, const GLint *);
void (APIENTRY *glMultiTexCoord1s) (GLenum, GLshort);
void (APIENTRY *glMultiTexCoord1sv) (GLenum, const GLshort *);
void (APIENTRY *glMultiTexCoord2d) (GLenum, GLdouble, GLdouble);
void (APIENTRY *glMultiTexCoord2dv) (GLenum, const GLdouble *);
void (APIENTRY *glMultiTexCoord2f) (GLenum, GLfloat, GLfloat);
void (APIENTRY *glMultiTexCoord2fv) (GLenum, const GLfloat *);
void (APIENTRY *glMultiTexCoord2i) (GLenum, GLint, GLint);
void (APIENTRY *glMultiTexCoord2iv) (GLenum, const GLint *);
void (APIENTRY *glMultiTexCoord2s) (GLenum, GLshort, GLshort);
void (APIENTRY *glMultiTexCoord2sv) (GLenum, const GLshort *);
void (APIENTRY *glMultiTexCoord3d) (GLenum, GLdouble, GLdouble, GLdouble);
void (APIENTRY *glMultiTexCoord3dv) (GLenum, const GLdouble *);
void (APIENTRY *glMultiTexCoord3f) (GLenum, GLfloat, GLfloat, GLfloat);
void (APIENTRY *glMultiTexCoord3fv) (GLenum, const GLfloat *);
void (APIENTRY *glMultiTexCoord3i) (GLenum, GLint, GLint, GLint);
void (APIENTRY *glMultiTexCoord3iv) (GLenum, const GLint *);
void (APIENTRY *glMultiTexCoord3s) (GLenum, GLshort, GLshort, GLshort);
void (APIENTRY *glMultiTexCoord3sv) (GLenum, const GLshort *);
void (APIENTRY *glMultiTexCoord4d) (GLenum, GLdouble, GLdouble, GLdouble, GLdouble);
void (APIENTRY *glMultiTexCoord4dv) (GLenum, const GLdouble *);
void (APIENTRY *glMultiTexCoord4f) (GLenum, GLfloat, GLfloat, GLfloat, GLfloat);
void (APIENTRY *glMultiTexCoord4fv) (GLenum, const GLfloat *);
void (APIENTRY *glMultiTexCoord4i) (GLenum, GLint, GLint, GLint, GLint);
void (APIENTRY *glMultiTexCoord4iv) (GLenum, const GLint *);
void (APIENTRY *glMultiTexCoord4s) (GLenum, GLshort, GLshort, GLshort, GLshort);
void (APIENTRY *glMultiTexCoord4sv) (GLenum, const GLshort *);
void (APIENTRY *glLoadTransposeMatrixf) (const GLfloat *);
void (APIENTRY *glLoadTransposeMatrixd) (const GLdouble *);
void (APIENTRY *glMultTransposeMatrixf) (const GLfloat *);
void (APIENTRY *glMultTransposeMatrixd) (const GLdouble *);
void (APIENTRY *glSampleCoverage) (GLclampf, GLboolean);
void (APIENTRY *glCompressedTexImage3D) (GLenum, GLint, GLenum, GLsizei, GLsizei, GLsizei, GLint, GLsizei, const GLvoid *);
void (APIENTRY *glCompressedTexImage2D) (GLenum, GLint, GLenum, GLsizei, GLsizei, GLint, GLsizei, const GLvoid *);
void (APIENTRY *glCompressedTexImage1D) (GLenum, GLint, GLenum, GLsizei, GLint, GLsizei, const GLvoid *);
void (APIENTRY *glCompressedTexSubImage3D) (GLenum, GLint, GLint, GLint, GLint, GLsizei, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid *);
void (APIENTRY *glCompressedTexSubImage2D) (GLenum, GLint, GLint, GLint, GLsizei, GLsizei, GLenum, GLsizei, const GLvoid *);
void (APIENTRY *glCompressedTexSubImage1D) (GLenum, GLint, GLint, GLsizei, GLenum, GLsizei, const GLvoid *);
void (APIENTRY *glGetCompressedTexImage) (GLenum, GLint, GLvoid *);


// OpenGL 1.4 Prototypes
void (APIENTRY *glBlendFuncSeparate) (GLenum, GLenum, GLenum, GLenum);
void (APIENTRY *glFogCoordf) (GLfloat);
void (APIENTRY *glFogCoordfv) (const GLfloat *);
void (APIENTRY *glFogCoordd) (GLdouble);
void (APIENTRY *glFogCoorddv) (const GLdouble *);
void (APIENTRY *glFogCoordPointer) (GLenum, GLsizei, const GLvoid *);
void (APIENTRY *glMultiDrawArrays) (GLenum, GLint *, GLsizei *, GLsizei);
void (APIENTRY *glMultiDrawElements) (GLenum, const GLsizei *, GLenum, const GLvoid* *, GLsizei);
void (APIENTRY *glPointParameterf) (GLenum, GLfloat);
void (APIENTRY *glPointParameterfv) (GLenum, const GLfloat *);
void (APIENTRY *glPointParameteri) (GLenum, GLint);
void (APIENTRY *glPointParameteriv) (GLenum, const GLint *);
void (APIENTRY *glSecondaryColor3b) (GLbyte, GLbyte, GLbyte);
void (APIENTRY *glSecondaryColor3bv) (const GLbyte *);
void (APIENTRY *glSecondaryColor3d) (GLdouble, GLdouble, GLdouble);
void (APIENTRY *glSecondaryColor3dv) (const GLdouble *);
void (APIENTRY *glSecondaryColor3f) (GLfloat, GLfloat, GLfloat);
void (APIENTRY *glSecondaryColor3fv) (const GLfloat *);
void (APIENTRY *glSecondaryColor3i) (GLint, GLint, GLint);
void (APIENTRY *glSecondaryColor3iv) (const GLint *);
void (APIENTRY *glSecondaryColor3s) (GLshort, GLshort, GLshort);
void (APIENTRY *glSecondaryColor3sv) (const GLshort *);
void (APIENTRY *glSecondaryColor3ub) (GLubyte, GLubyte, GLubyte);
void (APIENTRY *glSecondaryColor3ubv) (const GLubyte *);
void (APIENTRY *glSecondaryColor3ui) (GLuint, GLuint, GLuint);
void (APIENTRY *glSecondaryColor3uiv) (const GLuint *);
void (APIENTRY *glSecondaryColor3us) (GLushort, GLushort, GLushort);
void (APIENTRY *glSecondaryColor3usv) (const GLushort *);
void (APIENTRY *glSecondaryColorPointer) (GLint, GLenum, GLsizei, const GLvoid *);
void (APIENTRY *glWindowPos2d) (GLdouble, GLdouble);
void (APIENTRY *glWindowPos2dv) (const GLdouble *);
void (APIENTRY *glWindowPos2f) (GLfloat, GLfloat);
void (APIENTRY *glWindowPos2fv) (const GLfloat *);
void (APIENTRY *glWindowPos2i) (GLint, GLint);
void (APIENTRY *glWindowPos2iv) (const GLint *);
void (APIENTRY *glWindowPos2s) (GLshort, GLshort);
void (APIENTRY *glWindowPos2sv) (const GLshort *);
void (APIENTRY *glWindowPos3d) (GLdouble, GLdouble, GLdouble);
void (APIENTRY *glWindowPos3dv) (const GLdouble *);
void (APIENTRY *glWindowPos3f) (GLfloat, GLfloat, GLfloat);
void (APIENTRY *glWindowPos3fv) (const GLfloat *);
void (APIENTRY *glWindowPos3i) (GLint, GLint, GLint);
void (APIENTRY *glWindowPos3iv) (const GLint *);
void (APIENTRY *glWindowPos3s) (GLshort, GLshort, GLshort);
void (APIENTRY *glWindowPos3sv) (const GLshort *);

// OpenGL 1.5 Typedefs
typedef ptrdiff_t GLintptr;
typedef ptrdiff_t GLsizeiptr;

// OpenGL 1.5 Prototypes
void (APIENTRY *glGenQueries) (GLsizei, GLuint *);
void (APIENTRY *glDeleteQueries) (GLsizei, const GLuint *);
GLboolean (APIENTRY *glIsQuery) (GLuint);
void (APIENTRY *glBeginQuery) (GLenum, GLuint);
void (APIENTRY *glEndQuery) (GLenum);
void (APIENTRY *glGetQueryiv) (GLenum, GLenum, GLint *);
void (APIENTRY *glGetQueryObjectiv) (GLuint, GLenum, GLint *);
void (APIENTRY *glGetQueryObjectuiv) (GLuint, GLenum, GLuint *);
void (APIENTRY *glBindBuffer) (GLenum, GLuint);
void (APIENTRY *glDeleteBuffers) (GLsizei, const GLuint *);
void (APIENTRY *glGenBuffers) (GLsizei, GLuint *);
GLboolean (APIENTRY *glIsBuffer) (GLuint);
void (APIENTRY *glBufferData) (GLenum, GLsizeiptr, const GLvoid *, GLenum);
void (APIENTRY *glBufferSubData) (GLenum, GLintptr, GLsizeiptr, const GLvoid *);
void (APIENTRY *glGetBufferSubData) (GLenum, GLintptr, GLsizeiptr, GLvoid *);
GLvoid* (APIENTRY *glMapBuffer) (GLenum, GLenum);
GLboolean (APIENTRY *glUnmapBuffer) (GLenum);
void (APIENTRY *glGetBufferParameteriv) (GLenum, GLenum, GLint *);
void (APIENTRY *glGetBufferPointerv) (GLenum, GLenum, GLvoid* *);

extern  int   ( WINAPI * qwglChoosePixelFormat) (HDC, CONST PIXELFORMATDESCRIPTOR *);
extern  int   ( WINAPI * qwglDescribePixelFormat) (HDC, int, UINT, LPPIXELFORMATDESCRIPTOR);
extern  int   ( WINAPI * qwglGetPixelFormat) (HDC);
extern  BOOL  ( WINAPI * qwglSetPixelFormat) (HDC, int, CONST PIXELFORMATDESCRIPTOR *);
extern  BOOL  ( WINAPI * qwglSwapBuffers) (HDC);

extern BOOL  ( WINAPI * qwglCopyContext) (HGLRC, HGLRC, UINT);
extern HGLRC ( WINAPI * qwglCreateContext) (HDC);
extern HGLRC ( WINAPI * qwglCreateLayerContext) (HDC, int);
extern BOOL  ( WINAPI * qwglDeleteContext) (HGLRC);
extern HGLRC ( WINAPI * qwglGetCurrentContext) (VOID);
extern HDC   ( WINAPI * qwglGetCurrentDC) (VOID);
extern PROC  ( WINAPI * qwglGetProcAddress) (LPCSTR);
extern PROC  MHGLGetProcAddress (LPCSTR FuncName);
extern BOOL  ( WINAPI * qwglMakeCurrent) (HDC, HGLRC);
extern BOOL  ( WINAPI * qwglShareLists) (HGLRC, HGLRC);
extern BOOL  ( WINAPI * qwglUseFontBitmaps) (HDC, DWORD, DWORD, DWORD);

extern BOOL  ( WINAPI * qwglUseFontOutlines) (HDC, DWORD, DWORD, DWORD, FLOAT,
                                           FLOAT, int, LPGLYPHMETRICSFLOAT);

extern BOOL ( WINAPI * qwglDescribeLayerPlane) (HDC, int, int, UINT,
                                            LPLAYERPLANEDESCRIPTOR);
extern int  ( WINAPI * qwglSetLayerPaletteEntries) (HDC, int, int, int,
                                                CONST COLORREF *);
extern int  ( WINAPI * qwglGetLayerPaletteEntries) (HDC, int, int, int,
                                                COLORREF *);
extern BOOL ( WINAPI * qwglRealizeLayerPalette) (HDC, int, BOOL);
extern BOOL ( WINAPI * qwglSwapLayerBuffers) (HDC, UINT);

extern BOOL ( WINAPI * qwglSwapInterval) ( int interval );

extern BOOL ( WINAPI * qwglGetDeviceGammaRampEXT) ( unsigned char *pRed, unsigned char *pGreen, unsigned char *pBlue );
extern BOOL ( WINAPI * qwglSetDeviceGammaRampEXT) ( const unsigned char *pRed, const unsigned char *pGreen, const unsigned char *pBlue );

#endif
