

#include "quakedef.h"


#include "cvar.h"
#include "render.h"
#include "client.h"

#include "gl_model.h"
#include "glquake.h"

/*
===================
Do the MHQuake logo thang.

This only needs to be loaded once - the first time the console is displayed (which is normally
when the game starts up).  It's a fairly crude form of runlength encoding here but it works.

This image is only used in the console.
===================
*/
short MHQLogo[] = 
{
#include "mhlogo.h"
};


byte Logo_RPal[16] = {0, 16, 24, 41, 49, 57, 74, 86, 115, 144, 174, 210, 230, 247, 255, 255};
byte Logo_GPal[16] = {0, 8, 16, 24, 33, 41, 49, 53, 74, 94, 111, 136, 148, 156, 165, 255};
byte Logo_BPal[16] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255};

int logoTex;

void MHLoadLogo (void)
{
	int i;
	byte rgba[4];
	unsigned tex[256 * 64];
	int runlength;
	int j;
	int k;

	// get the data
	for (i = 0, j = 0; ;)
	{
		if (MHQLogo[i] == -1)
			break;
		else if (MHQLogo[i] > 16)
		{
			// read the runlength
			runlength = MHQLogo[i] - 16;

			// get the data position
			i++;

			// read the data
			rgba[0] = Logo_RPal[MHQLogo[i]];
			rgba[1] = Logo_GPal[MHQLogo[i]];
			rgba[2] = Logo_BPal[MHQLogo[i]];

			if (MHQLogo[i] == 0)
				rgba[3] = 0;
			else rgba[3] = 255;

			// write the data
			for (k = 0; k < runlength; k++)
				tex[j++] = *((unsigned *) &rgba[0]);

			// advance to the next slot
			i++;
		}
		else
		{
			// read the data
			rgba[0] = Logo_RPal[MHQLogo[i]];
			rgba[1] = Logo_GPal[MHQLogo[i]];
			rgba[2] = Logo_BPal[MHQLogo[i]];

			if (MHQLogo[i] == 0)
				rgba[3] = 0;
			else rgba[3] = 255;

			// write the data
			tex[j++] = *((unsigned *) &rgba[0]);

			// advance to the next slot
			i++;
		}
	}

	glBindTexture (GL_TEXTURE_2D, logoTex);

	glTexImage2D (GL_TEXTURE_2D, 
				  0, 
				  GL_RGBA, 
				  256, 
				  64, 
				  0, 
				  GL_RGBA, 
				  GL_UNSIGNED_BYTE, 
				  tex);

	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
}



