/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef GL_RGBA4
#define	GL_RGBA4	0x8056
#endif

#define	BLOCK_WIDTH		128
#define	BLOCK_HEIGHT	128
#define	MAX_LIGHTMAPS	64


typedef struct glRect_s 
{
	unsigned char l,t,w,h;
} glRect_t;

// 0 = card has negative lighting, 1 = card lights normally
int				nColinElim;
int				neglight;
int				lightmap_bytes;		// 1, 2, or 4
int				lightmap_textures;

unsigned		blocklights[BLOCK_WIDTH * BLOCK_HEIGHT];
unsigned		blocklightcolours[3][BLOCK_WIDTH * BLOCK_HEIGHT];

qboolean		lightmap_modified[MAX_LIGHTMAPS];
glRect_t		lightmap_rectchange[MAX_LIGHTMAPS];
int				allocated[MAX_LIGHTMAPS][BLOCK_WIDTH];
byte			lightmaps[MAX_LIGHTMAPS*BLOCK_WIDTH*BLOCK_HEIGHT*4];

mvertex_t		*r_pcurrentvertbase;
model_t			*currentmodel;

// gl struct
void GL_BuildVertexLightColour (glmsurface_t *fa);
void GL_BuildVertexLightWhite (glmsurface_t *fa);

// render struct
void R_RenderDynamicLightmaps (glmsurface_t *fa);
void R_RenderDynamicVertexLightmaps (glmsurface_t *fa);
void R_RenderDynamicWaterLightmaps (glmsurface_t *fa);

extern qboolean hlbsp;
extern cvar_t	gl_vertexlight;
extern int		gl_useclight;




