/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

entity_t	r_worldentity;

qboolean	envmap;							// true during envmap command capture 
qboolean	r_cache_thrash;					// compatability
qboolean	mirror_particles;

vec3_t		modelorg, r_entorigin;
entity_t	*currententity;
mplane_t	frustum[4];

int			r_visframecount;				// bumped when going to a new PVS
int			r_framecount;					// used for dlight push checking

int			cnttextures[2] = {-1, -1};      // cached
int			particletexture;				// little dot for particles
int			playertextures;					// up to 16 color translated skins

// view origin
vec3_t	vup;
vec3_t	vpn;
vec3_t	vright;
vec3_t	r_origin;

float sky_mult;
float r_world_matrix[16];
float PowerupGlowRadius = 0.0;				// variable with frametime for throbbing effect
float TorchGlowFlicker;						// variable for throbbing effect
float BoltGlowFlicker;

// screen size info
refdef_t	r_refdef;
mleaf_t		*r_viewleaf, *r_oldviewleaf;
mleaf_t		*r_viewleaf2, *r_oldviewleaf2;	// for watervis hack
gltexture_t	*r_notexture_mip;
int			d_lightstylevalue[256];			// 8.8 fraction of base light value

extern int		gl_fogenabled;
extern cvar_t   gl_fogstart;
extern cvar_t   gl_fogend;

extern cvar_t	r_particles;
extern cvar_t	r_drawdist;
extern cvar_t   r_autowatertrans;

// glow effects
#define MAX_GLOWS 2048
int num_glows;

// bulletholes
#define VectorScalarMult(a,b,c){c[0]=a[0]*b;c[1]=a[1]*b;c[2]=a[2]*b;}

typedef struct glows_s
{
	float red;
	float green;
	float blue;
	float radius;
	vec3_t origin;
} glows_t;

glows_t			glow_effects[MAX_GLOWS];
int				num_amodels;
int				num_amodel_glows;
int				num_amodel_shadows;

extern qboolean water_present;
extern qboolean inwater;

extern float r_waterfog_colour[4];
extern float r_waterfog_density;

// this is a global cos we need it in gl_rsurf too...
GLfloat		fog_colours[4];
float		frametime;
float		TGF_Tick = 0.0;
qboolean	PGR_Dir = true;
float		watermove;









