
#define MAX_PARTICLES			4096 // default max # of particles at one time
#define ABSOLUTE_MIN_PARTICLES	512  // no fewer than this no matter what's on the command line
#define NUM_EXPLODE_PARTICLES	128  // number of particles in an explosion
#define NUM_EXP_PARTS_CLASSIC	1024  // number of particles in an explosion - classic system

extern float frametime;
extern int	 oldtexture;

extern cvar_t  r_torchsmoke;
extern cvar_t  sv_gravity;

extern qboolean mirror_particles;

// these were in glquake.h but i moved them in here so that i can modify as required without
// having to recompile every bloody time!
typedef enum 
{
	// enhanced particle effects
	pt_static, 
	pt_grav, 
	pt_slowgrav, 
	pt_fire, 
	pt_explode, 
	pt_explode2, 
	pt_blob, 
	pt_blob2, 
	pt_blood,
	pt_tele, 
	pt_trail,
	pt_antigrav,

	// classic particle effects
	pt_static_classic,
	pt_grav_classic,
	pt_slowgrav_classic,
	pt_fire_classic,
	pt_explode_classic,
	pt_explode2_classic,
	pt_blob_classic,
	pt_blob2_classic,
	pt_blood_classic,
	pt_tele_classic,
	pt_trail_classic,
	pt_antigrav_classic
} ptype_t;

// !!! if this is changed, it must be changed in d_ifacea.h too !!!
// yeah, like fuck it must...
typedef struct mh_particle_s
{
	// driver-usable fields
	vec3_t		org;
	float		color;

	// drivers never touch the following fields
	struct mh_particle_s	*next;
	vec3_t		vel;
	float		ramp;
	float		die;
	ptype_t		type;

	// glquake only particle fields
	float		radius;
	float		alpha_val;
	float		vector_scale;
	int			particle_texture;
} mh_particle_t;


int		ramp1[8] = {0x6f, 0x6d, 0x6b, 0x69, 0x67, 0x65, 0x63, 0x61};
int		ramp2[8] = {0x6f, 0x6e, 0x6d, 0x6c, 0x6b, 0x6a, 0x68, 0x66};
int		ramp3[8] = {0x6d, 0x6b, 6, 5, 4, 3};

// blob ramps
int		ramp4[8] = {66, 67, 68, 69, 70, 71, 72, 73};
int		ramp5[8] = {150, 151, 152, 153, 154, 155, 156, 157};

mh_particle_t	*active_particles, *free_particles;

mh_particle_t	*particles;
int				r_numparticles;

vec3_t			r_pright, r_pup, r_ppn;

extern int smoketexture;
extern int bloodtexture;

#define NUMVERTEXNORMALS	162
extern	float	r_avertexnormals[NUMVERTEXNORMALS][3];
vec3_t	avelocities[NUMVERTEXNORMALS];
float	beamlength = 16;
vec3_t	avelocity = {23, 7, 3};
float	partstep = 0.01;
float	timescale = 0.01;

void R_AddGlowEffect (float red, float green, float blue, float radius, vec3_t origin);
