/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

extern cvar_t gl_vertexlight;
extern cvar_t gl_fullbright;
extern cvar_t gl_multitexture;

extern cvar_t gl_skyfog;
extern cvar_t gl_fogstart;
extern cvar_t gl_fogend;

extern cvar_t r_detailsky;
extern cvar_t r_waterwave;
extern cvar_t r_watershade;
extern cvar_t r_waterdlight;
extern cvar_t r_autowatertrans;

int gl_useclight;
int oldtexture;
int oldtexnum_mtex2;
int	skytexturenum;

extern int gl_fogenabled;
extern int lightmap_textures;
extern qboolean	lightmap_modified[MAX_LIGHTMAPS];

extern	mleaf_t		*r_viewleaf, *r_oldviewleaf;
extern	mleaf_t		*r_viewleaf2, *r_oldviewleaf2;	// for watervis hack

// make it easier to find out if we're drawing multitextured
qboolean MTexUse;

// function pointers for surface drawing
void (*ChainDrawer) ();
void (*BMPolyDrawer) ();

extern glRect_t	lightmap_rectchange[MAX_LIGHTMAPS];
extern int		lightmap_bytes;
extern byte		lightmaps[MAX_LIGHTMAPS*BLOCK_WIDTH*BLOCK_HEIGHT*4];
qboolean		water_present = false;
qboolean		force_vis = false;
qboolean		evil_hack;

// fog stuff
extern GLfloat  fog_colours[4];



// speed up sin calculations - Ed
float		 s_mody;
float		 t_mody;
extern float frametime;


float r_waterfog_colour[4];
float r_waterfog_density;

extern qboolean inwater;
extern qboolean hlbsp;

#define NO_TRANS	1.0
#define NO_WAVE		0.0
#define NO_SHADE	0.8

// poly struct
void EmitSimpleSkyPolys (glmsurface_t *fa);
void EmitWaterPolys (glmsurface_t *fa, float temp_wave, float trans_lev, float warp_factor);

// sky struct
void R_DrawSkyBox (void);
void R_ClearSkyBox (void);
void R_DrawOldSkyBox (void);
void R_DrawOldSkyboxChain (glmsurface_t *s);


