/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/*
Brightness
Moved here so it affects the 2D graphics as well.
*/
extern cvar_t   v_gamma;
extern cvar_t	crosshair;

// only the refresh window will be updated unless these variables are flagged 
int			glx, gly, glwidth, glheight;
int			scr_copytop;
int			scr_copyeverything;

float		scr_con_current;
float		scr_conlines;				// lines of console to display
float		oldscreensize, oldfov;


qpic_t		*scr_ram;
qpic_t		*scr_net;
qpic_t		*scr_turtle;

int			scr_fullupdate;
int			clearconsole;
int			clearnotify;

viddef_t	vid;						// global video state
vrect_t		scr_vrect;

qboolean	scr_disabled_for_loading;
qboolean	scr_drawloading;
qboolean	scr_initialized;			// ready to draw
qboolean	scr_drawdialog;
qboolean	block_drawing;
float		scr_disabled_time;

char		*scr_notifystring;
char		scr_centerstring[1024];
float		scr_centertime_start;		// for slow victory printing
float		scr_centertime_off;
int			scr_center_lines;
int			scr_erase_lines;
int			scr_erase_center;


extern qboolean r_mapshot;
extern int		mapshot_texturenum;
extern char		mapshot_string[1024];

// Screenshot struct
void SCR_ScreenShot_f (void);

// More of the same "typedefs"
void Draw_Image (int image_texnum, float x0, float y0, float x1, float y1);

// More of the same "typedefs"
void Draw_TextBox (int x, int y, int width, int lines);

typedef struct _TargaHeader 
{
	unsigned char 	id_length, colormap_type, image_type;
	unsigned short	colormap_index, colormap_length;
	unsigned char	colormap_size;
	unsigned short	x_origin, y_origin, width, height;
	unsigned char	pixel_size, attributes;
} TargaHeader;


