/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

byte	*mod_base;

// litfile header - darkplaces standard
typedef struct litheader_s
{
	char ident[4];
	int version;
} litheader_t;

extern model_t	*loadmodel;
extern char		loadname[32];	// for hunk tags

int		use_lit;
int		global_worldtype;
int		worldtype_found;

extern cvar_t gl_colouredlight;
extern cvar_t gl_fastbutugly;
extern cvar_t _r_skybox;

extern int gl_useclight;
extern int fog_colour[3];
extern int fog_density;

qboolean hlbsp;
qboolean qsg30;

float RadiusFromBounds (vec3_t mins, vec3_t maxs);

model_t *Mod_FindName (char *name);

int FindFullbrightTexture (byte *pixels, int num_pix);

void ConvertPixels (byte *pixels, int num_pixels);

void Host_LoadSkybox (char *sb_name, qboolean report);

void ParseEntityLump (lump_t *l);

void Mod_LoadHLLighting (lump_t *l);

void Mod_LoadHLTextures (miptex_t *mt, gltexture_t *tx, int pixels);



