#include "gl_backend_shared.h"


// defines

#define	BLOCK_WIDTH		128
#define	BLOCK_HEIGHT	128

#define	MAX_LIGHTMAPS	64


// externs
extern GLfloat VArray[MAXALIASVERTS * 9];

extern cvar_t scr_viewsize;
extern cvar_t scr_fov;
extern vrect_t	scr_vrect;
extern int	sb_lines;

extern qboolean scrap_dirty;

extern float rotateBack;
extern float rotateFore;

extern msurface_t *waterchain;

extern qboolean liquidRender;
extern qboolean skyRender;

extern 
glpoly_t	*lightmap_polys[MAX_LIGHTMAPS];

// typedefs
typedef struct glpic_s
{
	int				texnum;
	float			sl, tl, sh, th;
} glpic_t;



// prototypes
void Draw_ConsoleBackground (int lines);

void R_DrawAliasModelLOCK (entity_t *e, float Light, int skin, float trans);

void Draw_TextureMode_f (void);

void GL_Init (void);

void SCR_CalcRefdef (void);

void GL_Upload32 (unsigned *data, int width, int height,  qboolean mipmap, qboolean alpha);

void GL_Upload8 (byte *data, int width, int height,  qboolean mipmap, qboolean alpha);

int GL_LoadTexture (char *identifier, int width, int height, byte *data, qboolean mipmap, qboolean alpha);

int GL_LoadPicTexture (char *name, qpic_t *pic);

void GL_TexDump_f (void);

void GL_Set2D (void);

void GL_Draw2DPic (int x, int y, qpic_t *pic);

void GL_SubdivideSurface (msurface_t *fa);

void EmitWaterPolys (msurface_t *surf);

void R_DrawWorld (void);

void R_MarkLeaves (void);

void R_RecursiveWorldNode (mnode_t *node);

void R_InitSky (texture_t *mt);

void R_DrawSkyChain (void);

texture_t *R_TextureAnimation (texture_t *base);

void R_PushDlights (void);

void R_MarkLights (dlight_t *light, int bit, mnode_t *node);

void R_UpdateSurfaceLightmap (msurface_t *surf);

void R_BuildLightMap (msurface_t *surf, byte *dest, int stride);

void GL_BuildAllLightmaps (void);

void R_BlendLightmaps (void);







