
#include "quakedef.h"
#include "gl_frontend_shared.h"
#include "glext.h"



void GL_Draw2DPic (int x, int y, qpic_t *pic)
{
	glpic_t *gl;

	if (!pic) return;

	if (scrap_dirty) Scrap_Upload ();

	gl = (glpic_t *) pic->data;

	glColor4f (1, 1, 1, 1);

	glBindTexture (GL_TEXTURE_2D, gl->texnum);

	glBegin (GL_QUADS);

	glTexCoord2f (gl->sl, gl->tl);
	glVertex2f (x, y);

	glTexCoord2f (gl->sh, gl->tl);
	glVertex2f (x + pic->width, y);

	glTexCoord2f (gl->sh, gl->th);
	glVertex2f (x + pic->width, y + pic->height);

	glTexCoord2f (gl->sl, gl->th);
	glVertex2f (x, y + pic->height);

	glEnd ();
}


void GL_Set2D (void)
{
	glViewport (glx, gly, glwidth, glheight);

	glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();

	// 2D stuff always draws at 640 x 480
	glOrtho  (0, 640, 480, 0, -99999, 99999);

	glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();

	glDisable (GL_DEPTH_TEST);
	glDisable (GL_CULL_FACE);
	glDisable (GL_BLEND);
	glEnable (GL_ALPHA_TEST);

	glColor4f (1, 1, 1, 1);
}


