#include "quakedef.h"
#include "winquake.h"
#include "resource.h"
#include <commctrl.h>
#include "gl_frontend_shared.h"
#include "glext.h"



int maxGLSize;
int glTextureunits;


qboolean OGL12;
qboolean OGL13;
qboolean OGL14;


/*
================
GetGLCore

Get all the core OpenGL stuff.  No proprietary extensions are used by MHQuake - this is
all pure OpenGL.
================
*/
void GetGLCore (void)
{
	// we're assuming that OpenGL 1.1 is present.  MHQuake will fail anyway if either 1.2 to
	// 1.4 are absent, so this is a safe assumption.
	Con_Printf ("\nFound OpenGL 1.1 Support...\n");

	OGL12 = true;
	OGL13 = true;
	OGL14 = true;

	// OpenGL 1.2
	if (!(glBlendColor = (void *) wglGetProcAddress ("glBlendColor"))) OGL12 = false;
	if (!(glBlendEquation = (void *) wglGetProcAddress ("glBlendEquation"))) OGL12 = false;
	if (!(glDrawRangeElements = (void *) wglGetProcAddress ("glDrawRangeElements"))) OGL12 = false;
	if (!(glColorTable = (void *) wglGetProcAddress ("glColorTable"))) OGL12 = false;
	if (!(glColorTableParameterfv = (void *) wglGetProcAddress ("glColorTableParameterfv"))) OGL12 = false;
	if (!(glColorTableParameteriv = (void *) wglGetProcAddress ("glColorTableParameteriv"))) OGL12 = false;
	if (!(glCopyColorTable = (void *) wglGetProcAddress ("glCopyColorTable"))) OGL12 = false;
	if (!(glGetColorTable = (void *) wglGetProcAddress ("glGetColorTable"))) OGL12 = false;
	if (!(glGetColorTableParameterfv = (void *) wglGetProcAddress ("glGetColorTableParameterfv"))) OGL12 = false;
	if (!(glGetColorTableParameteriv = (void *) wglGetProcAddress ("glGetColorTableParameteriv"))) OGL12 = false;
	if (!(glColorSubTable = (void *) wglGetProcAddress ("glColorSubTable"))) OGL12 = false;
	if (!(glCopyColorSubTable = (void *) wglGetProcAddress ("glCopyColorSubTable"))) OGL12 = false;
	if (!(glConvolutionFilter1D = (void *) wglGetProcAddress ("glConvolutionFilter1D"))) OGL12 = false;
	if (!(glConvolutionFilter2D = (void *) wglGetProcAddress ("glConvolutionFilter2D"))) OGL12 = false;
	if (!(glConvolutionParameterf = (void *) wglGetProcAddress ("glConvolutionParameterf"))) OGL12 = false;
	if (!(glConvolutionParameterfv = (void *) wglGetProcAddress ("glConvolutionParameterfv"))) OGL12 = false;
	if (!(glConvolutionParameteri = (void *) wglGetProcAddress ("glConvolutionParameteri"))) OGL12 = false;
	if (!(glConvolutionParameteriv = (void *) wglGetProcAddress ("glConvolutionParameteriv"))) OGL12 = false;
	if (!(glCopyConvolutionFilter1D = (void *) wglGetProcAddress ("glCopyConvolutionFilter1D"))) OGL12 = false;
	if (!(glCopyConvolutionFilter2D = (void *) wglGetProcAddress ("glCopyConvolutionFilter2D"))) OGL12 = false;
	if (!(glGetConvolutionFilter = (void *) wglGetProcAddress ("glGetConvolutionFilter"))) OGL12 = false;
	if (!(glGetConvolutionParameterfv = (void *) wglGetProcAddress ("glGetConvolutionParameterfv"))) OGL12 = false;
	if (!(glGetConvolutionParameteriv = (void *) wglGetProcAddress ("glGetConvolutionParameteriv"))) OGL12 = false;
	if (!(glGetSeparableFilter = (void *) wglGetProcAddress ("glGetSeparableFilter"))) OGL12 = false;
	if (!(glSeparableFilter2D = (void *) wglGetProcAddress ("glSeparableFilter2D"))) OGL12 = false;
	if (!(glGetHistogram = (void *) wglGetProcAddress ("glGetHistogram"))) OGL12 = false;
	if (!(glGetHistogramParameterfv = (void *) wglGetProcAddress ("glGetHistogramParameterfv"))) OGL12 = false;
	if (!(glGetHistogramParameteriv = (void *) wglGetProcAddress ("glGetHistogramParameteriv"))) OGL12 = false;
	if (!(glGetMinmax = (void *) wglGetProcAddress ("glGetMinmax"))) OGL12 = false;
	if (!(glGetMinmaxParameterfv = (void *) wglGetProcAddress ("glGetMinmaxParameterfv"))) OGL12 = false;
	if (!(glGetMinmaxParameteriv = (void *) wglGetProcAddress ("glGetMinmaxParameteriv"))) OGL12 = false;
	if (!(glHistogram = (void *) wglGetProcAddress ("glHistogram"))) OGL12 = false;
	if (!(glMinmax = (void *) wglGetProcAddress ("glMinmax"))) OGL12 = false;
	if (!(glResetHistogram = (void *) wglGetProcAddress ("glResetHistogram"))) OGL12 = false;
	if (!(glResetMinmax = (void *) wglGetProcAddress ("glResetMinmax"))) OGL12 = false;
	if (!(glTexImage3D = (void *) wglGetProcAddress ("glTexImage3D"))) OGL12 = false;
	if (!(glTexSubImage3D = (void *) wglGetProcAddress ("glTexSubImage3D"))) OGL12 = false;
	if (!(glCopyTexSubImage3D = (void *) wglGetProcAddress ("glCopyTexSubImage3D"))) OGL12 = false;

	// OpenGL 1.3
	if (!(glActiveTexture = (void *) wglGetProcAddress ("glActiveTexture"))) OGL13 = false;
	if (!(glClientActiveTexture = (void *) wglGetProcAddress ("glClientActiveTexture"))) OGL13 = false;
	if (!(glMultiTexCoord1d = (void *) wglGetProcAddress ("glMultiTexCoord1d"))) OGL13 = false;
	if (!(glMultiTexCoord1dv = (void *) wglGetProcAddress ("glMultiTexCoord1dv"))) OGL13 = false;
	if (!(glMultiTexCoord1f = (void *) wglGetProcAddress ("glMultiTexCoord1f"))) OGL13 = false;
	if (!(glMultiTexCoord1fv = (void *) wglGetProcAddress ("glMultiTexCoord1fv"))) OGL13 = false;
	if (!(glMultiTexCoord1i = (void *) wglGetProcAddress ("glMultiTexCoord1i"))) OGL13 = false;
	if (!(glMultiTexCoord1iv = (void *) wglGetProcAddress ("glMultiTexCoord1iv"))) OGL13 = false;
	if (!(glMultiTexCoord1s = (void *) wglGetProcAddress ("glMultiTexCoord1s"))) OGL13 = false;
	if (!(glMultiTexCoord1sv = (void *) wglGetProcAddress ("glMultiTexCoord1sv"))) OGL13 = false;
	if (!(glMultiTexCoord2d = (void *) wglGetProcAddress ("glMultiTexCoord2d"))) OGL13 = false;
	if (!(glMultiTexCoord2dv = (void *) wglGetProcAddress ("glMultiTexCoord2dv"))) OGL13 = false;
	if (!(glMultiTexCoord2f = (void *) wglGetProcAddress ("glMultiTexCoord2f"))) OGL13 = false;
	if (!(glMultiTexCoord2fv = (void *) wglGetProcAddress ("glMultiTexCoord2fv"))) OGL13 = false;
	if (!(glMultiTexCoord2i = (void *) wglGetProcAddress ("glMultiTexCoord2i"))) OGL13 = false;
	if (!(glMultiTexCoord2iv = (void *) wglGetProcAddress ("glMultiTexCoord2iv"))) OGL13 = false;
	if (!(glMultiTexCoord2s = (void *) wglGetProcAddress ("glMultiTexCoord2s"))) OGL13 = false;
	if (!(glMultiTexCoord2sv = (void *) wglGetProcAddress ("glMultiTexCoord2sv"))) OGL13 = false;
	if (!(glMultiTexCoord3d = (void *) wglGetProcAddress ("glMultiTexCoord3d"))) OGL13 = false;
	if (!(glMultiTexCoord3dv = (void *) wglGetProcAddress ("glMultiTexCoord3dv"))) OGL13 = false;
	if (!(glMultiTexCoord3f = (void *) wglGetProcAddress ("glMultiTexCoord3f"))) OGL13 = false;
	if (!(glMultiTexCoord3fv = (void *) wglGetProcAddress ("glMultiTexCoord3fv"))) OGL13 = false;
	if (!(glMultiTexCoord3i = (void *) wglGetProcAddress ("glMultiTexCoord3i"))) OGL13 = false;
	if (!(glMultiTexCoord3iv = (void *) wglGetProcAddress ("glMultiTexCoord3iv"))) OGL13 = false;
	if (!(glMultiTexCoord3s = (void *) wglGetProcAddress ("glMultiTexCoord3s"))) OGL13 = false;
	if (!(glMultiTexCoord3sv = (void *) wglGetProcAddress ("glMultiTexCoord3sv"))) OGL13 = false;
	if (!(glMultiTexCoord4d = (void *) wglGetProcAddress ("glMultiTexCoord4d"))) OGL13 = false;
	if (!(glMultiTexCoord4dv = (void *) wglGetProcAddress ("glMultiTexCoord4dv"))) OGL13 = false;
	if (!(glMultiTexCoord4f = (void *) wglGetProcAddress ("glMultiTexCoord4f"))) OGL13 = false;
	if (!(glMultiTexCoord4fv = (void *) wglGetProcAddress ("glMultiTexCoord4fv"))) OGL13 = false;
	if (!(glMultiTexCoord4i = (void *) wglGetProcAddress ("glMultiTexCoord4i"))) OGL13 = false;
	if (!(glMultiTexCoord4iv = (void *) wglGetProcAddress ("glMultiTexCoord4iv"))) OGL13 = false;
	if (!(glMultiTexCoord4s = (void *) wglGetProcAddress ("glMultiTexCoord4s"))) OGL13 = false;
	if (!(glMultiTexCoord4sv = (void *) wglGetProcAddress ("glMultiTexCoord4sv"))) OGL13 = false;
	if (!(glLoadTransposeMatrixf = (void *) wglGetProcAddress ("glLoadTransposeMatrixf"))) OGL13 = false;
	if (!(glLoadTransposeMatrixd = (void *) wglGetProcAddress ("glLoadTransposeMatrixd"))) OGL13 = false;
	if (!(glMultTransposeMatrixf = (void *) wglGetProcAddress ("glMultTransposeMatrixf"))) OGL13 = false;
	if (!(glMultTransposeMatrixd = (void *) wglGetProcAddress ("glMultTransposeMatrixd"))) OGL13 = false;
	if (!(glSampleCoverage = (void *) wglGetProcAddress ("glSampleCoverage"))) OGL13 = false;
	if (!(glCompressedTexImage3D = (void *) wglGetProcAddress ("glCompressedTexImage3D"))) OGL13 = false;
	if (!(glCompressedTexImage2D = (void *) wglGetProcAddress ("glCompressedTexImage2D"))) OGL13 = false;
	if (!(glCompressedTexImage1D = (void *) wglGetProcAddress ("glCompressedTexImage1D"))) OGL13 = false;
	if (!(glCompressedTexSubImage3D = (void *) wglGetProcAddress ("glCompressedTexSubImage3D"))) OGL13 = false;
	if (!(glCompressedTexSubImage2D = (void *) wglGetProcAddress ("glCompressedTexSubImage2D"))) OGL13 = false;
	if (!(glCompressedTexSubImage1D = (void *) wglGetProcAddress ("glCompressedTexSubImage1D"))) OGL13 = false;
	if (!(glGetCompressedTexImage = (void *) wglGetProcAddress ("glGetCompressedTexImage"))) OGL13 = false;

	// OpenGL 1,4
	if (!(glBlendFuncSeparate = (void *) wglGetProcAddress ("glBlendFuncSeparate"))) OGL14 = false;
	if (!(glFogCoordf = (void *) wglGetProcAddress ("glFogCoordf"))) OGL14 = false;
	if (!(glFogCoordfv = (void *) wglGetProcAddress ("glFogCoordfv"))) OGL14 = false;
	if (!(glFogCoordd = (void *) wglGetProcAddress ("glFogCoordd"))) OGL14 = false;
	if (!(glFogCoorddv = (void *) wglGetProcAddress ("glFogCoorddv"))) OGL14 = false;
	if (!(glFogCoordPointer = (void *) wglGetProcAddress ("glFogCoordPointer"))) OGL14 = false;
	if (!(glMultiDrawArrays = (void *) wglGetProcAddress ("glMultiDrawArrays"))) OGL14 = false;
	if (!(glMultiDrawElements = (void *) wglGetProcAddress ("glMultiDrawElements"))) OGL14 = false;
	if (!(glPointParameterf = (void *) wglGetProcAddress ("glPointParameterf"))) OGL14 = false;
	if (!(glPointParameterfv = (void *) wglGetProcAddress ("glPointParameterfv"))) OGL14 = false;
	if (!(glPointParameteri = (void *) wglGetProcAddress ("glPointParameteri"))) OGL14 = false;
	if (!(glPointParameteriv = (void *) wglGetProcAddress ("glPointParameteriv"))) OGL14 = false;
	if (!(glSecondaryColor3b = (void *) wglGetProcAddress ("glSecondaryColor3b"))) OGL14 = false;
	if (!(glSecondaryColor3bv = (void *) wglGetProcAddress ("glSecondaryColor3bv"))) OGL14 = false;
	if (!(glSecondaryColor3d = (void *) wglGetProcAddress ("glSecondaryColor3d"))) OGL14 = false;
	if (!(glSecondaryColor3dv = (void *) wglGetProcAddress ("glSecondaryColor3dv"))) OGL14 = false;
	if (!(glSecondaryColor3f = (void *) wglGetProcAddress ("glSecondaryColor3f"))) OGL14 = false;
	if (!(glSecondaryColor3fv = (void *) wglGetProcAddress ("glSecondaryColor3fv"))) OGL14 = false;
	if (!(glSecondaryColor3i = (void *) wglGetProcAddress ("glSecondaryColor3i"))) OGL14 = false;
	if (!(glSecondaryColor3iv = (void *) wglGetProcAddress ("glSecondaryColor3iv"))) OGL14 = false;
	if (!(glSecondaryColor3s = (void *) wglGetProcAddress ("glSecondaryColor3s"))) OGL14 = false;
	if (!(glSecondaryColor3sv = (void *) wglGetProcAddress ("glSecondaryColor3sv"))) OGL14 = false;
	if (!(glSecondaryColor3ub = (void *) wglGetProcAddress ("glSecondaryColor3ub"))) OGL14 = false;
	if (!(glSecondaryColor3ubv = (void *) wglGetProcAddress ("glSecondaryColor3ubv"))) OGL14 = false;
	if (!(glSecondaryColor3ui = (void *) wglGetProcAddress ("glSecondaryColor3ui"))) OGL14 = false;
	if (!(glSecondaryColor3uiv = (void *) wglGetProcAddress ("glSecondaryColor3uiv"))) OGL14 = false;
	if (!(glSecondaryColor3us = (void *) wglGetProcAddress ("glSecondaryColor3us"))) OGL14 = false;
	if (!(glSecondaryColor3usv = (void *) wglGetProcAddress ("glSecondaryColor3usv"))) OGL14 = false;
	if (!(glSecondaryColorPointer = (void *) wglGetProcAddress ("glSecondaryColorPointer"))) OGL14 = false;
	if (!(glWindowPos2d = (void *) wglGetProcAddress ("glWindowPos2d"))) OGL14 = false;
	if (!(glWindowPos2dv = (void *) wglGetProcAddress ("glWindowPos2dv"))) OGL14 = false;
	if (!(glWindowPos2f = (void *) wglGetProcAddress ("glWindowPos2f"))) OGL14 = false;
	if (!(glWindowPos2fv = (void *) wglGetProcAddress ("glWindowPos2fv"))) OGL14 = false;
	if (!(glWindowPos2i = (void *) wglGetProcAddress ("glWindowPos2i"))) OGL14 = false;
	if (!(glWindowPos2iv = (void *) wglGetProcAddress ("glWindowPos2iv"))) OGL14 = false;
	if (!(glWindowPos2s = (void *) wglGetProcAddress ("glWindowPos2s"))) OGL14 = false;
	if (!(glWindowPos2sv = (void *) wglGetProcAddress ("glWindowPos2sv"))) OGL14 = false;
	if (!(glWindowPos3d = (void *) wglGetProcAddress ("glWindowPos3d"))) OGL14 = false;
	if (!(glWindowPos3dv = (void *) wglGetProcAddress ("glWindowPos3dv"))) OGL14 = false;
	if (!(glWindowPos3f = (void *) wglGetProcAddress ("glWindowPos3f"))) OGL14 = false;
	if (!(glWindowPos3fv = (void *) wglGetProcAddress ("glWindowPos3fv"))) OGL14 = false;
	if (!(glWindowPos3i = (void *) wglGetProcAddress ("glWindowPos3i"))) OGL14 = false;
	if (!(glWindowPos3iv = (void *) wglGetProcAddress ("glWindowPos3iv"))) OGL14 = false;
	if (!(glWindowPos3s = (void *) wglGetProcAddress ("glWindowPos3s"))) OGL14 = false;
	if (!(glWindowPos3sv = (void *) wglGetProcAddress ("glWindowPos3sv"))) OGL14 = false;

	if (OGL12)
		Con_Printf ("Found OpenGL 1.2 Support...\n");
	else Con_Printf ("OpenGL 1.2 not Supported...\n");

	if (OGL13)
		Con_Printf ("Found OpenGL 1.3 Support...\n");
	else Con_Printf ("OpenGL 1.3 not Supported...\n");

	if (OGL14)
		Con_Printf ("Found OpenGL 1.4 Support...\n");
	else Con_Printf ("OpenGL 1.4 not Supported...\n");

	if (OGL12 && OGL13 && OGL14)
		Con_Printf ("\nFull OpenGL Support required for MHQuake OK.\n");
	else
	{
		Con_Printf ("\nReduced OpenGL Support found\n");
		Con_Printf ("MHQuake should run, but may not look nice or be fast\n");
	}

	// get the maximum texture size
	glGetIntegerv (GL_MAX_TEXTURE_SIZE, &maxGLSize);
	Con_Printf ("\nMaximum Texture Size: %i x %i\n", maxGLSize, maxGLSize);

	// get the number of TMUs available
	glGetIntegerv (GL_MAX_TEXTURE_UNITS, &glTextureunits);
	Con_Printf("\nFound %i TMUs support.\n", glTextureunits);
}


/*
===============
GL_Init

Gets our openGL initialized for us, sets all the function pointers, displays some info
on the console, and sets the default states.
===============
*/
void GL_Init (void)
{
	gl_vendor = glGetString (GL_VENDOR);
	Con_Printf ("\nGL_VENDOR: %s\n", gl_vendor);

	gl_renderer = glGetString (GL_RENDERER);
	Con_Printf ("GL_RENDERER: %s\n", gl_renderer);

	gl_version = glGetString (GL_VERSION);
	Con_Printf ("GL_VERSION: %s\n", gl_version);

	gl_extensions = glGetString (GL_EXTENSIONS);
	Con_DPrintf ("GL_EXTENSIONS: %s\n", gl_extensions);

	GetGLCore ();

	// default states
	glClearColor (0.0, 0.0, 0,0);

	glCullFace(GL_FRONT);
	glEnable(GL_TEXTURE_2D);

	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, 0.666);

	glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);
	glShadeModel (GL_FLAT);

	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

	// set up the hints for drawing
	glHint (GL_POINT_SMOOTH_HINT, GL_NICEST);
	glHint (GL_LINE_SMOOTH_HINT, GL_NICEST);
	glHint (GL_POLYGON_SMOOTH_HINT, GL_NICEST);
	glHint (GL_FOG_HINT, GL_NICEST);
	glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glHint (GL_GENERATE_MIPMAP_HINT, GL_NICEST);
}


static HICON hIcon;

void NO__VID_Init (byte *palette)
{
	DEVMODE	devmode;

	memset (&devmode, 0, sizeof (devmode));

	hIcon = LoadIcon (global_hInstance, MAKEINTRESOURCE (IDI_ICON2));

	InitCommonControls ();
}

